<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="所属客户" prop="customerId">
        <el-input
          v-model="queryParams.customerId"
          placeholder="请输入所属客户"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="search" @click="handleQuery">搜索</el-button>
        <el-button icon="refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="plus"
          @click="handleAdd"
          v-hasPermi="['business:customer-staff:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['business:customer-staff:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['business:customer-staff:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="download"
          @click="handleExport"
          v-hasPermi="['business:customer-staff:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="memberList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="所属客户" align="center" prop="customerId" />
      <el-table-column label="员工姓名" align="center" prop="name" />
      <el-table-column label="性别" align="center" prop="sex" />
      <el-table-column label="员工职位" align="center" prop="post" />
      <el-table-column label="员工电话" align="center" prop="phone" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            link
            type="primary"
            icon="edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['business:customer-staff:edit']"
          >修改</el-button>
          <el-button
            link
            type="danger"
            icon="delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['business:customer-staff:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改客户人员信息对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="所属客户" prop="customerId">
          <el-select
            v-model="form.customerId"
            filterable
            remote
            placeholder="请输入关键词搜索"
            remote-show-suffix
            :remote-method="($event) => remoteMethod($event, remoteCustomer)"
            :loading="remoteLoading"
          >
            <el-option
              v-for="item in customerList"
              :key="item.id"
              :label="item.contactsName"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="员工姓名" prop="name">
          <el-input v-model="form.name" placeholder="请输入员工姓名" />
        </el-form-item>
        <el-form-item label="员工性别" prop="sex">
          <el-select v-model="form.type" placeholder="请选择性别">
            <el-option
              v-for="item in customer_sex"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="员工职位" prop="post">
          <el-input v-model="form.name" placeholder="请输入员工职位" />
        </el-form-item>
        <el-form-item label="员工电话" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入员工电话" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script setup>
import { listCustomerStaff, getCustomerStaff, delCustomerStaff, addCustomerStaff, updateCustomerStaff } from "@/api/customer/member";
import { listCustomer } from "@/api/customer/info";
import useForm from '@/hooks/useForm.js';
import useRemote from '@/hooks/useRemote.js';

const defaultForm = {
  id: null,
  code: null,
  name: null,
  contactsName: null,
  contactsPhone: null,
  type: null,
  businessStatus: null,
}

const defaultParams = {
  pageNum: 1,
  pageSize: 10,
  contactsName: null,
  type: null
}

const formRef = ref(null);
const queryRef = ref(null);

const { proxy } = getCurrentInstance()

const data = reactive({
  // 遮罩层
  loading: true,
  // 选中数组
  ids: [],
  // 非单个禁用
  single: true,
  // 非多个禁用
  multiple: true,
  // 显示搜索条件
  showSearch: true,
  // 总条数
  total: 0,
  // 分类表格数据
  memberList: [],
  customerList: [],
  // 弹出层标题
  title: "",
  // 是否显示弹出层
  open: false,
  // 表单校验
  rules: {
  }
})

const { loading, ids, single, multiple, showSearch, total, memberList, title, open, rules, customerList } = toRefs(data);

const { form, validateForm, resetForm } = useForm(formRef, defaultForm)
const { form: queryParams, resetForm: resetQueryForm } = useForm(queryRef, defaultParams)

const { customer_sex } = proxy.useDict('customer_sex')
getList();

const { loading: remoteLoading, remoteMethod } = useRemote();

function getList() {
  loading.value = true;
  listCustomerStaff(queryParams.value).then(response => {
    memberList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

function remoteCustomer (query) {
  const params = {
    pageNum: 1,
    pageSize: 20,
    contactsName: query
  }
  return listCustomer(params).then(resp => {
    return customerList.value = resp.rows;
  })
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  resetForm();
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  resetQueryForm();
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids = selection.map(item => item.id)
  single = selection.length!==1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加人员信息";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const id = row.id || ids.value
  getCustomerStaff(id).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改人员信息";
  });
}

/** 提交按钮 */
function submitForm() {
  validateForm.then(() => {
    if (form.value.id != null) {
      updateCustomerStaff(form.value).then(response => {
        proxy.$modal.msgSuccess("修改成功");
        open.value = false;
        getList();
      });
    } else {
      addCustomerStaff(form.value).then(response => {
        proxy.$modal.msgSuccess("新增成功");
        open.value = false;
        getList();
      });
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除分类编号为"' + ids + '"的数据项？').then(function() {
    return delCustomerStaff(ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('business/customer-staff/export', {
    ...queryParams.value
  }, `customer_${new Date().getTime()}.xlsx`)
}
</script>
